"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require('fs');
var path = require('path');
var acorn_1 = require("./acorn");
var processFile = function (content) {
    return acorn_1.parse(content);
};
var SourceFileCache = /** @class */ (function () {
    function SourceFileCache() {
        this.data = new Map();
    }
    SourceFileCache.prototype.getFile = function (filePath) {
        if (this.data.has(filePath)) {
            return this.data.get(filePath);
        }
        else {
            var parsePromise = new Promise(function (resolve, reject) {
                fs.readFile(filePath, function (err, content) {
                    if (err) {
                        reject(err);
                    }
                    else {
                        resolve({
                            ast: processFile(content),
                            content: content,
                            fileName: path.basename(filePath),
                            filePath: filePath,
                        });
                    }
                });
            });
            this.data.set(filePath, parsePromise);
            return parsePromise;
        }
    };
    return SourceFileCache;
}());
exports.SourceFileCache = SourceFileCache;
//# sourceMappingURL=tree.js.map